<?php
/*
===========================用户控制器
^^^^^^^^^^^^^^^^^^成员
------添加(on_insert)
------修改(on_update)
------删除(on_del)

*/
class cls_tab_hr_resume_collect extends cls_base_table
{
	private $obj_db;
	//构造函数
	function __construct()
	{
		global $obj_db;
		parent::__construct();
		$this->obj_db=$obj_db;
	}
	/*添加
	arr_fields:关健字数组
	*/
	function on_save($arr_fields,$str_where="")
	{
		$arr_return=array("err"=>"","id"=>0);
		//保存操作
		if(isset($arr_fields["collect_id"])) unset($arr_fields["collect_id"]);//释放id
		$arr_fields["collect_addtime"]=TIME;
		$arr_return=self::chk_collect();
		if($arr_return["err"]!="") return $arr_return;
		$arr_return=self::_insert($arr_fields);
		return $arr_return;
	}
	//检查企业是否有收藏职位的权限
	function chk_collect(){
		global $obj_ctl_user,$obj_tab_sys_config;
		$arr_cfg_company=$obj_tab_sys_config->get_model("company");
		$arr_return=array("err"=>"");
		if($obj_ctl_user->type!="company"){
			$arr_return["err"]="您不是企业会员不能收藏个人简历！";
			return $arr_return;
		}
		//查看企业已经发送面试邀请数量
		$obj_rs   = $this->obj_db->get_one("SELECT count(*) as num FROM ".DB_PRE."hr_resume_collect where collect_user_id='".$obj_ctl_user->id."'");
		$lng_collectnum=$obj_rs["num"];
		//查看企业是否为VIP会员
		$obj_result = $this->obj_db->query("SELECT company_vip_id,company_vip_time FROM ".DB_PRE."hr_company where company_user_id='".$obj_ctl_user->id."'");
		if($obj_rs = $this->obj_db->fetch_array($obj_result))
		{
			if($obj_rs["company_vip_id"]>0){//VIP类型有效，按VIP设置
				$obj_result2 = $this->obj_db->query("SELECT vip_collectnum,vip_days FROM ".DB_PRE."hr_company_vip where vip_id='".$obj_rs["company_vip_id"]."'");
				if($obj_rs2 = $this->obj_db->fetch_array($obj_result2))
				{
					$lng_time=$obj_rs2["vip_days"]*86400+$obj_rs["company_vip_time"];
					if($lng_time>TIME||$obj_rs2["vip_days"]<1){
						if($obj_rs2["vip_collectnum"]>0&&$obj_rs2["vip_collectnum"]>$lng_collectnum){
							//检测通过，允许发送
							return $arr_return;
						}else if($obj_rs2["vip_collectnum"]<0){
							//不限发布数量，允许发送
							return $arr_return;
						}else{
							//为0，不允许发送
							if($obj_rs2["vip_collectnum"]>0){
								$arr_return["err"]="您的企业所属VIP会员只能收藏".$obj_rs2["vip_collectnum"]."次简历，请联系工作人员升级";
							}else{
								$arr_return["err"]="您的企业所属VIP会员没有收藏个人简历的权限，请联系工作人员升级";
							}
							return $arr_return;
						}
					}else{
						$arr_return["err"]="您的企业所属VIP会员已过期，请联系工作人员！";
						return $arr_return;
					}
				}else{
					$arr_return["err"]="您的企业所属VIP会员已过期，请联系工作人员！";
					return $arr_return;
				}
			}else{//否则按系统默认设置
				if(isset($arr_cfg_company["resume_collect_num"])){
					$lng_val=intval($arr_cfg_company["resume_collect_num"]);
					if($lng_val>$lng_collectnum){
						return $arr_return;
					}else if($lng_val<0){//小于0，不限发送数量
						return $arr_return;
					}else{
						if($lng_collectnum>0){
							$arr_return["err"]="您没有加入VIP会员，只能收藏".$lng_val."次个人简历！";
						}else{
							$arr_return["err"]="您没有收藏个人简历的权限，请加入VIP会员吧！";
						}
						return $arr_return;
					}
				}else{
					$arr_return["err"]="您没有收藏个人简历的权限，请加入VIP会员吧！";
					return $arr_return;
				}
			}
		}else{
			$arr_return["err"]="您不是企业会员或您没有填写企业必要资料不能收藏个人简历！";
			return $arr_return;
		}
	}
	function _insert($arr_fields)
	{
		$arr_return=array("err"=>"","id"=>0);
		if(!isset($arr_fields["collect_user_id"])||intval($arr_fields["collect_user_id"])<1){
			$arr_return["err"]="您没有登录或你不是企业会员！";
			return $arr_return;
		}
		if(!isset($arr_fields["collect_resume_user_id"])||intval($arr_fields["collect_resume_user_id"])<1){
			$arr_return["err"]="收藏的人才简历不存在！";
			return $arr_return;
		}
		$obj_result = $this->obj_db->query("SELECT * FROM ".DB_PRE."hr_resume_collect where collect_user_id='".$arr_fields["collect_user_id"]."' and collect_resume_user_id='".$arr_fields["collect_resume_user_id"]."'");
		if($obj_rs = $this->obj_db->fetch_array($obj_result))
		{
			$arr_return["err"]="该人才您已经收藏过了！";
			return $arr_return;
		}else{
			$arr_return=parent::on_insert(DB_PRE."hr_resume_collect",$arr_fields);
		}
		return $arr_return;
	}
	function on_del($arr_id)
	{
		$arr_return=array("err"=>"");
		$str_id=get_arr_id($arr_id);
		if($str_id==""){
			$arr_return["err"]="没有指定要删除的记录！";
			return $arr_return;
		}
		$arr_return=parent::on_del(DB_PRE."hr_resume_collect","collect_id in(".$str_id.")");

		return $arr_return;
	}
}
?>
